#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void BuildTree(long k, long nFirstVert)
{
	if (k == 1) return;

	BuildTree(k-1, nFirstVert);
	BuildTree(k-1, nFirstVert + (1<<(k-2)));

	printf("%ld %ld\n", nFirstVert + (1<<(k-2))-1, nFirstVert + (1<<(k-1))-1);
}

int main(void)
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long k;

	while (scanf("%ld", &k) == 1)
	{
		printf("%ld %ld\n", 1<<(k-1), (1<<(k-1)) -1);

		BuildTree(k, 1);

		for (long i = 1; i <= 1<<(k-1); ++i)
		{
			if (i > 1) putchar (' ');

			printf("%ld", i);
		}

		putchar('\n');
	}

#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif

	return 0;
}